#include <lz2a.h>
#include <time.h>

#include <core_all.c>
//#include <mdct.c>
#include <mdct2.c>
#include <mdctarith.c>

int main(int argc, char *argv[])
{
	short *ibuf, *obuf;
	int *tbuf, *idxbuf;
	byte *cbuf;
	FILE *fd;
	int i, cnt, cnt2;

	fd=fopen(argv[1], "rb");
	fseek(fd, 0, 2);
	i=ftell(fd);
	fseek(fd, 0, 0);

//	return(0);

	ibuf=malloc(i+2048);
	memset(ibuf, 0, i+2048);
	fread(ibuf, 1, i, fd);
	fclose(fd);

//	return(0);

	cnt=i/2;
	cnt2=(cnt+1023)&(~1023);
	obuf=malloc(cnt2*sizeof(short));
	tbuf=malloc(cnt2*sizeof(int));
	idxbuf=malloc((cnt2/MDCT_BLKSZ)*sizeof(int));

	memset(obuf, 0, cnt2*sizeof(short));
	memset(tbuf, 0, cnt2*sizeof(int));

	MDCT_FilterAudio(ibuf, tbuf, idxbuf, cnt);
	IMDCT_FilterAudio(tbuf, obuf, idxbuf, cnt);

	cbuf=malloc(cnt2*4);
	MDCTArith_SetupEncode(cbuf);
	MDCTArith_EncodeBlocks(tbuf, cnt/MDCT_BLKSZ, MDCT_BLKSZ);
	i=MDCTArith_FinishEncode(cbuf);

	printf("arith %d\n", i);

	printf("approx bitrate %fkbps\n", ((i*8)/(cnt/44100.0))/1000.0);

	fd=fopen(argv[2], "wb");
	fwrite(obuf, 2, cnt, fd);
	fclose(fd);
}
